#!/bin/sh

#
# monpstree.sh - affiche la liste des processus en cours sous forme d'arbre
#
# Description :
# monpstree.sh affiche la liste des processus en cours sous forme d'arbre,
# comme peut le faire la commande pstree. Sauf que ce script de 30 lignes
# prend moins de place que la commande binaire.
#
# Fichiers :
# 	/proc/[0-9]+/stat : les infos sur les processus en cours
#
# Voir aussi :
# pstree(1)
#

FicTmp=/tmp/`basename $0`.$$

cat /proc/*/stat | sort -n > $FicTmp

AfficheFils ()
{
    Fils=$1
    local Espace="$2"
    grep "^[^ ]* [^ ]* [^ ]* $Fils " $FicTmp | while read ligne
    do
        set -- $ligne
    local Espace2="$Espace "
    i=0
    while [ $i -lt `echo "$4" | wc -c` ]
    do
        Espace2="$Espace2 "
        i=`expr $i + 1`
    done

        echo -n "$Espace-$4-+-"
        echo "$1 $2 $3"
        AfficheFils $1 "$Espace2|"
    done
}

AfficheFils 1 "|"

rm -f $FicTmp

